## dahdi-tools 2.7.0

=== Makefile ===
#
# Makefile for DAHDI tools
#
# Copyright (C) 2001-2010 Digium, Inc.
#
#

ifeq ($(strip $(foreach var,clean distclean dist-clean update,$(findstring $(var),$(MAKECMDGOALS)))),)
endif

ifeq ($(strip $(foreach var,clean distclean dist-clean update,$(findstring $(var),$(MAKECMDGOALS)))),)
 ifneq ($(wildcard makeopts),)
  include makeopts
 endif
endif

SUBDIRS_UTILS_ALL:= ppp
SUBDIRS_UTILS := xpp

OPTFLAGS=-O2
CFLAGS+=-I. $(OPTFLAGS) -g -fPIC -Wall -DBUILDING_TONEZONE #-DTONEZONE_DRIVER
ifneq (,$(findstring ppc,$(UNAME_M)))
CFLAGS+=-fsigned-char
endif
ifneq (,$(findstring x86_64,$(UNAME_M)))
CFLAGS+=-m64
endif

ifeq ($(DAHDI_DEVMODE),yes)
  CFLAGS+=-Werror -Wunused -Wundef $(DAHDI_DECLARATION_AFTER_STATEMENT) -Wmissing-format-attribute -Wformat-security #-Wformat=2
endif

ROOT_PREFIX=

# extra cflags to build dependencies. Recursively expanded.
MAKE_DEPS= -MD -MT $@ -MF .$(subst /,_,$@).d -MP

CFLAGS+=$(DAHDI_INCLUDE)

CHKCONFIG	:= $(wildcard /sbin/chkconfig)
UPDATE_RCD	:= $(wildcard /usr/sbin/update-rc.d)
ifeq (,$(DESTDIR))
  ifneq (,$(CHKCONFIG))
    ADD_INITD	:= $(CHKCONFIG) --add dahdi
  else
    ifneq (,$(UPDATE_RCD))
      ADD_INITD	:= $(UPDATE_RCD) dahdi defaults 15 30
    endif
  endif
endif

INITRD_DIR	:= $(firstword $(wildcard $(DESTDIR)/etc/rc.d/init.d $(DESTDIR)/etc/init.d))
ifneq (,$(INITRD_DIR))
  INIT_TARGET	:= $(INITRD_DIR)/dahdi
  COPY_INITD	:= install -D dahdi.init $(INIT_TARGET)
endif

RCCONF_FILE	= /etc/dahdi/init.conf
MODULES_FILE	= /etc/dahdi/modules
GENCONF_FILE	= /etc/dahdi/genconf_parameters
MODPROBE_FILE	= /etc/modprobe.d/dahdi.conf
BLACKLIST_FILE	= /etc/modprobe.d/dahdi.blacklist.conf

NETSCR_DIR	:= $(firstword $(wildcard $(DESTDIR)/etc/sysconfig/network-scripts ))
ifneq (,$(NETSCR_DIR))
  NETSCR_TARGET	:= $(NETSCR_DIR)/ifup-hdlc
  COPY_NETSCR	:= install -D ifup-hdlc $(NETSCR_TARGET)
endif

ifneq ($(wildcard .version),)
  TOOLSVERSION:=$(shell cat .version)
else
ifneq ($(wildcard .svn),)
  TOOLSVERSION=$(shell build_tools/make_version . dahdi/tools)
endif
endif

LTZ_A:=libtonezone.a
LTZ_A_OBJS:=zonedata.o tonezone.o version.o
LTZ_SO:=libtonezone.so
LTZ_SO_OBJS:=zonedata.lo tonezone.lo version.o
LTZ_SO_MAJOR_VER:=2
LTZ_SO_MINOR_VER:=0

# sbindir, libdir, includedir and mandir are defined in makeopts
# (from configure).
BIN_DIR:=$(sbindir)
LIB_DIR:=$(libdir)
INC_DIR:=$(includedir)/dahdi
MAN_DIR:=$(mandir)/man8
DATA_DIR:=${datadir}/dahdi
CONFIG_DIR:=$(sysconfdir)/dahdi
CONFIG_FILE:=$(CONFIG_DIR)/system.conf

# Utilities we build with a standard build procedure:
UTILS		= dahdi_tool dahdi_test dahdi_monitor dahdi_speed sethdlc dahdi_cfg \
		  fxstest fxotune dahdi_diag dahdi_scan

# some tests:
UTILS		+= patgen pattest patlooptest hdlcstress hdlctest hdlcgen \
		   hdlcverify timertest dahdi_maint


BINS:=fxotune dahdi_cfg dahdi_monitor dahdi_speed dahdi_test dahdi_scan dahdi_maint
ifeq	(1,$(PBX_NEWT))
	BINS	+= dahdi_tool
endif
ifeq	(1,$(PBX_HDLC))
	BINS	+= sethdlc
endif
MAN_PAGES:=$(wildcard $(BINS:%=doc/%.8))

PINNED_DATA_SCRIPTS:=dahdi_cfg_device_args handle_device \
	span_assignments span_types
PINNED_UTILS:=dahdi_map
PINNED_CONF:=pinned-spans.conf spantype.conf

TEST_BINS:=patgen pattest patlooptest hdlcstress hdlctest hdlcgen hdlcverify timertest dahdi_maint
# All the man pages. Not just installed ones:
GROFF_PAGES	:= $(wildcard doc/*.8 xpp/*.8)
GROFF_HTML	:= $(GROFF_PAGES:%=%.html)

GENERATED_DOCS	:= $(GROFF_HTML) README.html README.Astribank.html

all: prereq programs

libs: $(LTZ_SO) $(LTZ_A)

utils-subdirs:
	@for dir in $(SUBDIRS_UTILS); do \
		$(MAKE) -C $$dir; \
	done

programs: libs utils

utils: $(BINS) utils-subdirs

version.c: FORCE
	@TOOLSVERSION="${TOOLSVERSION}" build_tools/make_version_c > $@.tmp
	@if cmp -s $@.tmp $@ ; then :; else \
		mv $@.tmp $@ ; \
	fi
	@rm -f $@.tmp

tests: $(TEST_BINS)

$(UTILS): %: %.o

$(UTILS): version.o

%.o: %.c
	$(CC) $(CFLAGS) $(MAKE_DEPS) -c -o $@ $<

%.lo: %.c
	$(CC) $(CFLAGS) $(MAKE_DEPS) -c -o $@ $<

%: %.o
	$(CC) $(LDFLAGS) $^ $(LIBS) -o $@

prereq: config.status

dahdi_tool: CFLAGS+=$(NEWT_INCLUDE)
dahdi_tool: LIBS+=$(NEWT_LIB)

dahdi_speed: CFLAGS+=-O0

$(LTZ_A): $(LTZ_A_OBJS)
	ar rcs $@ $^
	ranlib $@

$(LTZ_SO): $(LTZ_SO_OBJS)
	$(CC) $(CFLAGS) -shared -Wl,-soname,$(LTZ_SO).$(LTZ_SO_MAJOR_VER).$(LTZ_SO_MINOR_VER) -o $@ $^ -lm

dahdi_cfg: $(LTZ_A)
dahdi_cfg: LIBS+=-lm
dahdi_pcap:
	$(CC) $(CFLAGS) dahdi_pcap.c -lpcap -o $@ $<
	

fxstest: $(LTZ_SO)
fxstest: LIBS+=-lm
fxotune: LIBS+=-lm

tonezones.txt: zonedata.c
	perl -ne 'next unless (/\.(country|description) = *"([^"]*)/); \
		print (($$1 eq "country")? "* $$2\t":"$$2\n");' $<  \
	>$@

%.asciidoc: %.sample
	perl -n -e \
		'if (/^#($$|\s)(.*)/){ if (!$$in_doc){print "\n"}; $$in_doc=1; print "$$2\n" } else { if ($$in_doc){print "\n"}; $$in_doc=0; print "  $$_" }' \
		$< \
	| perl -p -e 'if (/^  #?(\w+)=/ && ! exists $$cfgs{$$1}){my $$cfg = $$1; $$cfgs{$$cfg} = 1; s/^/\n[[cfg_$$cfg]]\n/}'  >$@

docs: $(GENERATED_DOCS)

genconf_parameters.sample: xpp/genconf_parameters
	cp $< $@

README.html: README system.conf.asciidoc init.conf.asciidoc tonezones.txt \
  UPGRADE.txt genconf_parameters.asciidoc
	$(ASCIIDOC) -n -a toc -a toclevels=3 $<

README.Astribank.html: xpp/README.Astribank
	$(ASCIIDOC) -o $@ -n -a toc -a toclevels=4 $<

# on Debian: this requires the full groof, not just groff-base.
%.8.html: %.8
	man -Thtml $^ >$@

htmlman: $(GROFF_HTML)

install: all install-programs
	@echo "###################################################"
	@echo "###"
	@echo "### DAHDI tools installed successfully."
	@echo "### If you have not done so before, install init scripts with:"
	@echo "###"
	@echo "###   make config"
	@echo "###"
	@echo "###################################################"

install-programs: install-utils install-libs

install-utils: utils install-utils-subdirs
ifneq (,$(BINS))
	install -d $(DESTDIR)$(BIN_DIR)
	install  $(BINS) $(DESTDIR)$(BIN_DIR)/
	install -d $(DESTDIR)$(MAN_DIR)
	install -m 644 $(MAN_PAGES) $(DESTDIR)$(MAN_DIR)/
endif
ifeq (,$(wildcard $(DESTDIR)$(CONFIG_FILE)))
	$(INSTALL) -d $(DESTDIR)$(CONFIG_DIR)
	$(INSTALL) -m 644 system.conf.sample $(DESTDIR)$(CONFIG_FILE)
endif
ifeq ($(DAHDI_PINNED),yes)
	install -d $(DESTDIR)$(DATA_DIR)
	install $(PINNED_DATA_SCRIPTS) $(DESTDIR)$(DATA_DIR)/
	install $(PINNED_UTILS) $(DESTDIR)/$(BIN_DIR)/
	install -m 644 $(PINNED_CONF) $(DESTDIR)/$(CONFIG_DIR)/
endif

install-libs: libs
	$(INSTALL) -d -m 755 $(DESTDIR)/$(LIB_DIR)
	$(INSTALL) -m 755 $(LTZ_A) $(DESTDIR)$(LIB_DIR)/
	$(INSTALL) -m 755 $(LTZ_SO) $(DESTDIR)$(LIB_DIR)/$(LTZ_SO).$(LTZ_SO_MAJOR_VER).$(LTZ_SO_MINOR_VER)
ifeq (,$(DESTDIR))
	if [ `id -u` = 0 ]; then \
		/sbin/ldconfig || : ;\
	fi
endif
	rm -f $(DESTDIR)$(LIB_DIR)/$(LTZ_SO)
	$(LN) -sf $(LTZ_SO).$(LTZ_SO_MAJOR_VER).$(LTZ_SO_MINOR_VER) \
		$(DESTDIR)$(LIB_DIR)/$(LTZ_SO).$(LTZ_SO_MAJOR_VER)
	$(LN) -sf $(LTZ_SO).$(LTZ_SO_MAJOR_VER).$(LTZ_SO_MINOR_VER) \
		$(DESTDIR)$(LIB_DIR)/$(LTZ_SO)
	# Overwrite the 1.0 links out there.  dahdi-tools 2.0.0 installed
	# 1.0 links but dahdi-tools changed them to 2.0 in order to explicitly
	# break applications linked with zaptel.  But, this also meant that
	# applications linked with libtonezone.so.1.0 broke when dahdi-tools
	# 2.1.0 was installed.
	$(LN) -sf $(LTZ_SO).$(LTZ_SO_MAJOR_VER).$(LTZ_SO_MINOR_VER) \
		$(DESTDIR)$(LIB_DIR)/$(LTZ_SO).1.0
	$(LN) -sf $(LTZ_SO).$(LTZ_SO_MAJOR_VER).$(LTZ_SO_MINOR_VER) \
		$(DESTDIR)$(LIB_DIR)/$(LTZ_SO).1
ifneq (no,$(USE_SELINUX))
  ifeq (,$(DESTDIR))
	/sbin/restorecon -v $(DESTDIR)$(LIB_DIR)/$(LTZ_SO)
  endif
endif
	$(INSTALL) -d -m 755 $(DESTDIR)/$(INC_DIR)
	$(INSTALL) -m 644 tonezone.h $(DESTDIR)$(INC_DIR)/

install-utils-subdirs:
	@for dir in $(SUBDIRS_UTILS); do \
		$(MAKE) -C $$dir install; \
	done

install-tests: tests
ifneq (,$(TEST_BINS))
	install -d $(DESTDIR)$(BIN_DIR)
	install  $(TEST_BINS) $(DESTDIR)$(BIN_DIR)/
endif

config:
ifneq (,$(COPY_INITD))
	$(COPY_INITD)
endif
ifeq (,$(wildcard $(DESTDIR)$(RCCONF_FILE)))
	$(INSTALL) -D -m 644 init.conf.sample $(DESTDIR)$(RCCONF_FILE)
endif
ifeq (,$(wildcard $(DESTDIR)$(MODULES_FILE)))
	$(INSTALL) -D -m 644 modules.sample $(DESTDIR)$(MODULES_FILE)
endif
ifeq (,$(wildcard $(DESTDIR)$(GENCONF_FILE)))
	$(INSTALL) -D -m 644 xpp/genconf_parameters $(DESTDIR)$(GENCONF_FILE)
endif
ifeq (,$(wildcard $(DESTDIR)$(MODPROBE_FILE)))
	$(INSTALL) -D -m 644 modprobe.conf.sample $(DESTDIR)$(MODPROBE_FILE)
endif
ifeq (,$(wildcard $(DESTDIR)$(BLACKLIST_FILE)))
	$(INSTALL) -D -m 644 blacklist.sample $(DESTDIR)$(BLACKLIST_FILE)
endif
ifneq (,$(COPY_NETSCR))
	$(COPY_NETSCR)
endif
ifneq (,$(ADD_INITD))
	$(ADD_INITD)
endif
	@echo "DAHDI has been configured."
	@echo ""
	@echo "List of detected DAHDI devices:"
	@echo ""
	@if [ `xpp/dahdi_hardware | tee /dev/stderr | wc -l` -eq 0 ]; then \
		echo "No hardware found"; \
	else \
		echo ""; \
		echo "run 'dahdi_genconf modules' to load support for only " ;\
		echo "the DAHDI hardware installed in this system.  By "; \
		echo "default support for all DAHDI hardware is loaded at "; \
		echo "DAHDI start. "; \
	fi

update:
	@if [ -d .svn ]; then \
		echo "Updating from Subversion..." ; \
		svn update | tee update.out; \
		rm -f .version; \
		if [ `grep -c ^C update.out` -gt 0 ]; then \
			echo ; echo "The following files have conflicts:" ; \
			grep ^C update.out | cut -b4- ; \
		fi ; \
		rm -f update.out; \
	else \
		echo "Not under version control";  \
	fi

clean:
	rm -f $(BINS) $(TEST_BINS)
	rm -f *.o dahdi_cfg tzdriver sethdlc
	rm -f $(LTZ_SO) $(LTZ_A) *.lo
	@for dir in $(SUBDIRS_UTILS_ALL); do \
		$(MAKE) -C $$dir clean; \
	done
	@for dir in $(SUBDIRS_UTILS); do \
		$(MAKE) -C $$dir clean; \
	done
	rm -f libtonezone*
	rm -f fxotune
	rm -f core
	rm -f dahdi_cfg-shared fxstest
	rm -rf $(GENERATED_DOCS) *.asciidoc tonezones.txt
	rm -f dahdi_pcap

distclean: dist-clean

dist-clean: clean
	rm -f makeopts
	rm -f config.log config.status
	rm -f .*.d

config.status: configure
	@CFLAGS="" ./configure
	@echo "****"
	@echo "**** The configure script was just executed, so 'make' needs to be"
	@echo "**** restarted."
	@echo "****"
	@exit 1

.PHONY: distclean dist-clean clean all install programs tests devel data config update install-programs install-libs install-utils-subdirs utils-subdirs prereq

FORCE:

ifneq ($(wildcard .*.d),)
   include .*.d
endif

=== ppp/Makefile ===
#COPTS	= -O2 -g

-include ../makeopts

CFLAGS		+= $(COPTS) -fPIC
LDFLAGS		+= -shared

INCLUDE_DIR	= $(includedir)/pppd

LIBDIR		= $(libdir)/pppd/$(PPPD_VERSION)

PLUGINS := dahdi.so

all:	$(PLUGINS)

%.so: %.c
ifeq (,$(PPPD_VERSION))
	@echo "pppd version not found (in patchlevel.h)."
	@echo "Install ppp source/headers and/or ./configure --with-ppp=PATH."
	exit 1
endif
	$(CC) -o $@ $(CFLAGS) $^ $(LDFLAGS) 

install: $(PLUGINS)
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)
	$(INSTALL) -m 0644 $? $(DESTDIR)$(LIBDIR)

clean:
	rm -f *.o *.so *.a

=== xpp/Makefile ===
PEDANTIC	= -ansi -pedantic -std=c99

INSTALL		= install
INSTALL_DATA	= install -m 644

#
# Ugly hack to find kernel directories before/after the split
# to kernel/user-space.
#
# These variables should be passed to us. But until then...
#
DAHDI_TOOLSDIR	?= ..
DAHDI_KERNELDIR	=

-include $(DAHDI_TOOLSDIR)/makeopts

INSTALL_DATA	= $(INSTALL) -m 644

# In 1.4 those are provided by autoconf through makeopts
prefix		?= /usr
datadir		?= $(prefix)/share
mandir		?= $(datadir)/man
INSTALL		?= install

INSTALL_DATA	= $(INSTALL) -m 644

SBINDIR		= $(prefix)/sbin
DATADIR		= $(datadir)/dahdi
MANDIR		= $(mandir)/man8
HOTPLUG_USB_DIR	= $(sysconfdir)/hotplug/usb
PERLLIBDIR	:= $(shell eval `perl -V:sitelib`; echo "$$sitelib")
PERL_DIRS	:= $(shell cd perl_modules; find * -name '[A-Z]*' -type d| xargs)
PERL_MODS_PAT	:= *.pm $(PERL_DIRS:%=%/*.pm)
PERL_MODS	:= $(shell cd perl_modules; echo $(PERL_MODS_PAT))

# Variables that should be defined above, but need sane defaults:
# FIXME: Are those values really sane?
HOSTCC		?= $(CC)

USE_OCTASIC	:= yes
OCTASIC_DIR	:= oct612x

ifneq (no,$(USE_OCTASIC))

OCT_OBJS	= $(shell $(OCTASIC_DIR)/octasic-helper objects $(OCTASIC_DIR))
OCT_SRCS	= $(shell echo $(OCT_OBJS) | tr -s ' ' '\n' | sed 's/\.o$$/.c/g')
OCT_HERE_OBJS	= $(shell echo $(OCT_OBJS) | tr -s ' ' '\n' | sed 's,^.*/,,')
OCT_CFLAGS	= $(shell $(OCTASIC_DIR)/octasic-helper cflags $(OCTASIC_DIR))
OCT_DEFINES	= \
	-DPTR_TYPE=uint32_t	\
	-DcOCT6100_INTERNAL_SUPER_ARRAY_SIZE=1024	\
	-DcOCT6100_MAX_ECHO_CHANNELS=672		\
	-DcOCT6100_MAX_MIXER_EVENTS=1344

ECHO_LOADER	= echo_loader.o
endif

%.8: %
	pod2man --section 8 $^ > $@ || $(RM) $@
PERL_SCRIPTS	=	\
		dahdi_registration	\
		xpp_sync	\
		lsdahdi		\
		xpp_blink	\
		dahdi_genconf	\
		dahdi_hardware	\
		twinstar	\
		#

PERL_MANS	= $(PERL_SCRIPTS:%=%.8)

XTALK_OBJS		= xtalk/xtalk.o xtalk/xusb.o xtalk/xlist.o xtalk/debug.o
ASTRIBANK_OBJS		= astribank_usb.o mpptalk.o $(XTALK_OBJS)

ABHEXLOAD_OBJS		= astribank_hexload.o hexfile.o pic_loader.o $(ECHO_LOADER) $(ASTRIBANK_OBJS) $(OCT_HERE_OBJS)
ABTOOL_OBJS		= astribank_tool.o $(ASTRIBANK_OBJS)
ABALLOW_OBJS		= astribank_allow.o astribank_license.o $(ASTRIBANK_OBJS)

TARGETS	= .perlcheck astribank_is_starting
PROG_INSTALL	= astribank_is_starting
MAN_INSTALL	= $(PROG_INSTALL:%=%.8)
ifeq	(1,$(PBX_USB))
TARGETS	+= \
	   astribank_tool	\
	   astribank_hexload	\
	   astribank_allow	\
	   test_parse
PROG_INSTALL	+= astribank_tool astribank_hexload astribank_allow
endif
ifneq	(,$(PERLLIBDIR))
PROG_INSTALL	+= $(PERL_SCRIPTS)
TARGETS		+= $(PERL_MANS)
endif

all: $(TARGETS)

docs: $(PERL_MANS)

install: all
	$(INSTALL) -d $(DESTDIR)$(SBINDIR)
	$(INSTALL) $(PROG_INSTALL) $(DESTDIR)$(SBINDIR)/
	$(INSTALL) -d $(DESTDIR)$(DATADIR)
	$(INSTALL) xpp_fxloader astribank_hook $(DESTDIR)$(DATADIR)/
	$(INSTALL) waitfor_xpds $(DESTDIR)$(DATADIR)/
	$(INSTALL) -d $(DESTDIR)$(MANDIR)
	$(INSTALL_DATA) $(MAN_INSTALL) $(DESTDIR)$(MANDIR)/
	$(INSTALL) -d $(DESTDIR)$(HOTPLUG_USB_DIR)
	$(INSTALL_DATA) xpp_fxloader.usermap $(DESTDIR)$(HOTPLUG_USB_DIR)/
	# for backward compatibility and for hotplug users:
	ln -sf $(DATADIR)/xpp_fxloader $(DESTDIR)$(HOTPLUG_USB_DIR)/
ifneq	(,$(PERLLIBDIR))
	$(INSTALL) -d $(DESTDIR)$(PERLLIBDIR)
	for i in $(PERL_DIRS); \
	do \
		$(INSTALL) -d "$(DESTDIR)$(PERLLIBDIR)/$$i"; \
	done
	for i in $(PERL_MODS); \
	do \
		$(INSTALL_DATA) "perl_modules/$$i" "$(DESTDIR)$(PERLLIBDIR)/$$i"; \
	done
endif

CFLAGS		+= -I. -Ixtalk

astribank_hexload: $(ABHEXLOAD_OBJS)
astribank_hexload: LIBS+=$(EXTRA_LIBS) $(USB_LIB)
astribank_hexload: CFLAGS+=$(OCT_CFLAGS)

astribank_tool: $(ABTOOL_OBJS)
astribank_tool: LIBS+=$(EXTRA_LIBS) $(USB_LIB)

astribank_allow: $(ABALLOW_OBJS)
astribank_allow: LIBS+=$(EXTRA_LIBS) $(USB_LIB)

astribank_is_starting: astribank_is_starting.o
astribank_is_starting: LIBS+=$(EXTRA_LIBS)

hex2iic: hex2iic.o iic.o hexfile.o

test_parse: test_parse.o hexfile.o
test_parse: LIBS+=$(EXTRA_LIBS) $(USB_LIB)

ifneq (no,$(USE_OCTASIC))
.octasic.depend: $(OCTASIC_DIR)/octasic-helper Makefile ../config.status
	$(CC) -MM $(OCT_CFLAGS) \
		`$(OCTASIC_DIR)/octasic-helper objects | \
		tr -s ' ' '\n' | \
		sed -e 's,.*,$(OCTASIC_DIR)/&,' -e 's/\.o$$/.c/'` > $@

-include .octasic.depend

$(OCT_HERE_OBJS): Makefile
	$(CC) -c $(CFLAGS) $(OCT_CFLAGS) $(OCT_DEFINES) $(OCT_SRCS)

endif


%: %.o
	$(CC) $(LDFLAGS) $^ $(LIBS) -o $@

.perlcheck: $(PERL_SCRIPTS)
	for i in $^; do perl -I./perl_modules -c $$i || exit 1; done
	touch $@

clean:
	$(RM) .depend .octasic.depend *.o xtalk/*.o $(OCT_HERE_OBJS) $(TARGETS)

.PHONY: depend
depend: .depend
.depend: *.c *.h xtalk/*.c xtalk/*.h
	@$(CC) $(CFLAGS) -MM *.c xtalk/*.c > $@ || rm -f $@

include .depend

=== xpp/oct612x/Makefile ===
CFLAGS=-V3.4 -ffunction-sections -I/lib/modules/$(shell uname -r)/build/include -Iinclude -Ioctdeviceapi -Ioctdeviceapi/oct6100api -DGFP_ATOMIC=0 -Dkmalloc=calloc -Dkfree=free
LDFLAGS=-V3.4 -Wl,-Map -Wl,test.map -Wl,--gc-sections

APIDIR=octdeviceapi/oct6100api/oct6100_api

OCTASIC_OBJS=$(APIDIR)/oct6100_adpcm_chan.o \
	    $(APIDIR)/oct6100_channel.o \
	    $(APIDIR)/oct6100_chip_open.o \
	    $(APIDIR)/oct6100_chip_stats.o \
	    $(APIDIR)/oct6100_conf_bridge.o \
	    $(APIDIR)/oct6100_debug.o \
	    $(APIDIR)/oct6100_events.o \
	    $(APIDIR)/oct6100_interrupts.o \
	    $(APIDIR)/oct6100_memory.o \
	    $(APIDIR)/oct6100_miscellaneous.o \
	    $(APIDIR)/oct6100_mixer.o \
	    $(APIDIR)/oct6100_phasing_tsst.o \
	    $(APIDIR)/oct6100_playout_buf.o \
	    $(APIDIR)/oct6100_remote_debug.o \
	    $(APIDIR)/oct6100_tlv.o \
	    $(APIDIR)/oct6100_tone_detection.o \
	    $(APIDIR)/oct6100_tsi_cnct.o \
	    $(APIDIR)/oct6100_tsst.o \
	    $(APIDIR)/oct6100_user.o \
	    apilib/bt/octapi_bt0.o \
	    apilib/largmath/octapi_largmath.o \
	    apilib/llman/octapi_llman.o


all: test

test.o: test.c

test: test.o $(OCTASIC_OBJS)

clean:
	rm -rf test test.o
	rm -rf $(OCTASIC_OBJS)

=== debian/changelog ===
dahdi-tools (1:2.7.0-1ubuntu1) saucy; urgency=low

  * Merge from debian. Remaining changes:
    - debian/control: Added gawk as dependency for dkms build
    - debian/control: Package dahdi Depends on dahdi-dkms | dahdi-source
    - debian/control: Set ubuntu maintainer    
    - added debian/dahdi.postinst
    - debian/control: Removed Uploaders field.
    - added debian/dahdi.postinst
    - added --error-handler=init_failed to debian/rules
    
 -- Jackson Doak <noskcaj@ubuntu.com>  Sun, 25 Aug 2013 12:48:37 +1000

dahdi-tools (1:2.7.0-1) unstable; urgency=low

  [ Tzafrir Cohen ]
  * New upstream release (Closes: #688919)
    - Patch fix_xpp_buildfix removed: merged upstream.
  * Patch fix_xpp_buildfix: The sole (currently) change in the upcoming
    dahdi-tools 2.6.3. A further build fix for gcc 4.8 (Closes: #707391).
  * Enable pinned spans support.

  [ Mark Purcell ] 
  * Fix "FTBFS: astribank_hexload.c:36:27: fatal error: ../autoconfig.h:
    No such file or directory" new upstream release (Closes: #707391)

 -- Mark Purcell <msp@debian.org>  Sun, 16 Jun 2013 16:37:00 +1000

dahdi-tools (1:2.4.1-1ubuntu3) saucy; urgency=low

  * debian/control: Restore Debian VCS/uploader information, as there is no
    need to remove it. Furthermore, the Vcs-Bzr field contained a Launchpad
    branch that doesn't exist.

 -- Logan Rosen <logan@ubuntu.com>  Thu, 23 May 2013 01:37:46 -0400

dahdi-tools (1:2.4.1-1ubuntu2) precise; urgency=low

  * No-change rebuild against current pkgbinarymangler to fix broken
    md5sums. (see LP #875466)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 29 Feb 2012 08:29:15 +0100

dahdi-tools (1:2.4.1-1ubuntu1) oneiric; urgency=low

  * Merge from Debian. Remaining changes:
    - Bug Fix: If linux-headers are not installed, don't block, and print
      information for the user.
    - added debian/dahdi.postinst
    - added --error-handler=init_failed to debian/rules
    - Changes from Debian:
      - debian/control: Change Maintainer
      - debian/control: Removed Uploaders field.
      - debian/control: Removed Debian Vcs-Svn entry and replaced with
        ubuntu-voip Vcs-Bzr, to reflect divergence in packages.
      - debian/control: Package dahdi Depends on dahdi-dkms | dahdi-source
  * debian/control: Added gawk as dependency for dkms build (LP: #493304)

 -- Stefan Lesicnik <stefan@lsd.co.za>  Sun, 08 May 2011 14:18:11 +0200

dahdi-tools (1:2.2.1.1-1ubuntu1) natty; urgency=low

  * Merge from Debian testing. Remaining changes:
    - Bug Fix: If linux-headers are not installed, don't block, and print
      information for the user.
      - added debian/dahdi.postinst
      - added --error-handler=init_failed to debian/rules
    - Changes from Debian:
      - debian/control: Change Maintainer
      - debian/control: Removed Uploaders field.
      - debian/control: Removed Debian Vcs-Svn entry and replaced with
        ubuntu-voip Vcs-Bzr, to reflect divergence in packages.
      - debian/control: Package dahdi Depends on  dahdi-dkms | dahdi-source

 -- Stefan Lesicnik <stefan@lsd.co.za>  Thu, 11 Nov 2010 12:43:00 +0200

dahdi-tools (1:2.2.1-0ubuntu2) lucid; urgency=low

  * Bug Fix: If linux-headers are not installed, don't block, and print
     information for the user. (LP: #429510, LP: #474350)
     - added debian/dahdi.postinst
     - added --error-handler=init_failed to debian/rules

 -- Jean-Michel Dault <jmdault@revolutionlinux.com>  Tue, 13 Apr 2010 16:56:27 -0400

dahdi-tools (1:2.2.1-0ubuntu1) lucid; urgency=low

  * Merge from Debian pkg-voip.
    * Changes from Debian:
    - debian/control: Change Maintainer
    - debian/control: Removed Uploaders field.
    - debian/control: Removed Debian Vcs-Svn entry and replaced with
        ubuntu-voip Vcs-Bzr, to reflect divergence in packages.
    - debian/control: Package dahdi Depends on  dahdi-dkms | dahdi-source

  * From Debian pkg-voip:
  [ Tzafrir Cohen ]
  * New upstream release (Closes: #536257, #564381).
  * Patch 'bashism' dropped: merged upstream. 
  * Patch xpp_no_extra_at dropped: merged upstream. 
  * Add an example genconf_parameters.
  * Compat level 7.
  * Bump standars version to 3.8.3.0 (no change needed)
  * Udev rules are now in dahdi-linux.
  * Patches perl_fix_noserial, perl_fix_transportdir: Fixes for some
    minor perl issues.
  * Add the missing ${misc:Depends}, as per lintian. 
  * Patch astribank_allow_ignoreend: an extra missing patch from upstream. 
  * Patches init_unload_modules and init_unload_oslec: also unload OSLEC
    when unloading all modules.

 -- Jean-Michel Dault <jmdault@revolutionlinux.com>  Tue, 16 Feb 2010 13:44:09 -0500

=== debian/control ===
Source: dahdi-tools
Section: comm
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
# groff, man-db and asciidoc are required for generating documentation
Build-Depends: debhelper (>= 8), dahdi-source (>= 1:2.3.0), libnewt-dev, bzip2, libusb-dev, 
 asciidoc, groff, man-db
Standards-Version: 3.9.2
Homepage: http://www.asterisk.org/
Vcs-Svn: svn://svn.debian.org/pkg-voip/dahdi-tools/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-voip/dahdi-tools/?op=log

Package: dahdi
Architecture: linux-any
#Jmdault 20090601: the init scripts needs the kernel drivers, so we require
#either the dkms module (preferred) or the source pkg (with module-assistant)
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}, procps, fxload, dahdi-linux, dahdi-dkms | dahdi-source, gawk
Conflicts: zaptel
Replaces: zaptel
Description: utilities for using the DAHDI kernel modules
 DAHDI (formly Zaptel) is an interface for telephony devices used by e.g. 
 the Asterisk PBX software. The dahdi-* packages provide the kernel 
 DAHDI kernel modules and their required setup environment.
 .
 This package includes userspace utilities required to configure DAHDI 
 modules.

Package: libtonezone2.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tonezone library (runtime)
 A library for generating tones to be sent through the DAHDI telephony
 interface.

Package: libtonezone-dev
Section: libdevel
Architecture: any
Depends: libtonezone2.0 (= ${binary:Version}), ${misc:Depends}
Description: tonezone library (development)
 A library for generating tones to be sent through the DAHDI telephony
 interface.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif

PREFIX:=dahdi
PACKAGE_SRC:=$(PREFIX)-tools

DEBVERSION:=$(shell head -n 1 debian/changelog \
		    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
DEB_BASE_VERSION:=$(shell echo $(DEBVERSION) | sed -e 's/^.*://' -e 's/-[0-9.]*$$//')
UPVERSION:=$(shell echo $(DEB_BASE_VERSION) | sed -e 's/~dfsg\(~\|$$\)/\1/' -e 's/~\(rc\|beta\)/-\1/')

UPFILENAME := $(PACKAGE_SRC)_$(UPVERSION).orig.tar.gz
FILENAME := $(PACKAGE_SRC)_$(DEB_BASE_VERSION).orig.tar.gz
URL := http://downloads.asterisk.org/pub/telephony/$(PACKAGE_SRC)/releases/$(PACKAGE_SRC)-$(UPVERSION).tar.gz

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-pinned

override_dh_auto_build:
	$(MAKE) programs docs
	# FIXME: xpp/README.Astribank.html

override_dh_auto_install:
	# Without this dahdi.init does not get copied:
	mkdir -p $(CURDIR)/debian/tmp/etc/init.d
	# also run the 'config' target, in addition to the 'install' target:
	dh_auto_install -- config

override_dh_installinit:
	dh_installinit --onlyscripts -p dahdi --error-handler=init_failed

print-version:
	@@echo "Debian version:          $(DEBVERSION)"
	@@echo "Upstream version:        $(UPVERSION)"

TARBALL_DIR=../tarballs/zaptel-$(UPVERSION).tmp
get-orig-source:
	@@dh_testdir
	@@[ -d ../tarballs/. ]||mkdir -p ../tarballs
	@@echo Downloading $(UPFILENAME) from $(URL) ...
	@@wget  -nv -T10 -t3 --verbose -O ../tarballs/$(FILENAME) $(URL)

=== debian/watch ===
version=3
opts=uversionmangle=s/-rc/\~rc/; \
	http://downloads.asterisk.org/pub/telephony/dahdi-tools/releases/dahdi-tools-(.*)\.tar\.gz\
	debian svn-upgrade

## dahdi-tools 2.7.0.1

=== debian/changelog ===
dahdi-tools (1:2.7.0.1-1) unstable; urgency=low

  * New upstream release

  [ Tzafrir Cohen ]
  * Remove HTMLed man pages (Closes: #714705).
  * Upstream init script will no longer barf if no DAHDI modules on system
    (Closes: #706046).
  * Only build on Linux. At least until someone packages dahdi-kfreebsd.
  * Use upstream's udev rules.
  * Use root:comm rather than asterisk:asterisk in udev rules.
  * hotplug support:
    - Add hotplug patches (an experimental git branch) - fixes to scriptary.
    - Remove the init script.

  [ Mark Purcell ]
  * Build-Depends: dahdi-source (>= 1:2.7)
  * Update Vcs_Browser - fixes vcs-field-bitrotted
  * Add dh $@ --with autotools_dev - fixes outdated-autotools-helper-file
  * Update Vcs_Svn - fixes vcs-field-not-canonical
  * Update Standards-Version - fixes ancient-standards-version

 -- Mark Purcell <msp@debian.org>  Sat, 12 Oct 2013 15:06:25 +1100

=== debian/control ===
Source: dahdi-tools
Section: comm
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Tzafrir Cohen <tzafrir@debian.org>, Mark Purcell <msp@debian.org>
# groff, man-db and asciidoc are required for generating documentation
Build-Depends: debhelper (>= 8), autotools-dev,
 dahdi-source (>= 1:2.7), libnewt-dev, bzip2, libusb-dev, asciidoc, groff, man-db
Standards-Version: 3.9.4
Homepage: http://www.asterisk.org/
Vcs-Svn: svn://anonscm.debian.org/pkg-voip/dahdi-tools/trunk/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-voip/dahdi-tools/

Package: dahdi
Architecture: linux-any
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}, procps, fxload, dahdi-linux
Conflicts: zaptel
Replaces: zaptel
Description: utilities for using the DAHDI kernel modules
 DAHDI (formly Zaptel) is an interface for telephony devices used by e.g. 
 the Asterisk PBX software. The dahdi-* packages provide the kernel 
 DAHDI kernel modules and their required setup environment.
 .
 This package includes userspace utilities required to configure DAHDI 
 modules.

Package: libtonezone2.0
Section: libs
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tonezone library (runtime)
 A library for generating tones to be sent through the DAHDI telephony
 interface.
 .
 This package contains the runtime library files.

Package: libtonezone-dev
Section: libdevel
Architecture: linux-any
Depends: libtonezone2.0 (= ${binary:Version}), ${misc:Depends}
Description: tonezone library (development)
 A library for generating tones to be sent through the DAHDI telephony
 interface.
 .
 This package contains the development files.

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 URL := http://downloads.asterisk.org/pub/telephony/$(PACKAGE_SRC)/releases/$(PACKAGE_SRC)-$(UPVERSION).tar.gz
 
 %:
-	dh $@
+	dh $@ --wth autotools_dev
 
 override_dh_auto_configure:
 	dh_auto_configure -- --enable-pinned
@@ -30,15 +30,12 @@
 override_dh_auto_build:
 	$(MAKE) programs docs
 	# FIXME: xpp/README.Astribank.html
+	cp dahdi.rules debian/dahdi.udev
+
 
 override_dh_auto_install:
-	# Without this dahdi.init does not get copied:
-	mkdir -p $(CURDIR)/debian/tmp/etc/init.d
 	# also run the 'config' target, in addition to the 'install' target:
 	dh_auto_install -- config
-
-override_dh_installinit:
-	dh_installinit --onlyscripts -p dahdi --error-handler=init_failed
 
 print-version:
 	@@echo "Debian version:          $(DEBVERSION)"
@@ -50,3 +47,4 @@
 	@@[ -d ../tarballs/. ]||mkdir -p ../tarballs
 	@@echo Downloading $(UPFILENAME) from $(URL) ...
 	@@wget  -nv -T10 -t3 --verbose -O ../tarballs/$(FILENAME) $(URL)
+

## dahdi-tools 2.10.0

=== debian/changelog ===
dahdi-tools (1:2.10.0-1) unstable; urgency=low

  * New upstream release candidate:
    - Init script no longer exists if no system.conf (Closes: #567072).
    - hotplug/* patches removed (a better version included upstream).
    - example_scriptlet removed: merged upstream.
  * Don't add spans automatically in Asterisk (it's the job of asterisk).
  * Also depend on usbutils: xpp_fxloader uses lsusb.
  * xpp_revert_clear_halt.patch: fixes a regression since 2.9.2.

 -- Tzafrir Cohen <tzafrir@debian.org>  Tue, 19 Aug 2014 08:56:07 +0300

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 Package: dahdi
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}, procps, fxload, dahdi-linux
+Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}, procps, fxload, dahdi-linux, usbutils
 Conflicts: zaptel
 Replaces: zaptel
 Description: utilities for using the DAHDI kernel modules

## dahdi-tools 2.10.0.1

=== debian/changelog ===
dahdi-tools (1:2.10.0.1-1ubuntu1) vivid; urgency=low

  * Merge from Debian. Remaining changes:
    - debian/control: Depend on (dahdi-dkms | dahdi-source) and gawk
  * Dropped changes:
    - debian/dahdi.postinst: Upstream init script does not fail if no
      dahdi modules are present, so no use for the error handler in the
      postinst file.
    - debian/rules: For the same reason no need to set an error handler
      in the rules file.

 -- Stefan Bader <stefan.bader@canonical.com>  Wed, 10 Dec 2014 15:23:10 +0100

dahdi-tools (1:2.10.0.1-1) unstable; urgency=low

  * New upstream release (Closes: #765377).
    - xpp_revert_clear_halt.patch merged upstream.
  * Compat level 9.
  * debian-cflags.patch: some cases where build flags were not passed 
  * Multi-arch headers.

 -- Tzafrir Cohen <tzafrir@debian.org>  Sun, 26 Oct 2014 20:46:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: dahdi-tools
 Section: comm
 Priority: optional
-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Tzafrir Cohen <tzafrir@debian.org>, Mark Purcell <msp@debian.org>
 # groff, man-db and asciidoc are required for generating documentation
 Build-Depends: debhelper (>= 8), autotools-dev,
@@ -13,7 +14,10 @@
 
 Package: dahdi
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}, procps, fxload, dahdi-linux, usbutils
+Multi-Arch: foreign
+#Jmdault 20090601: the init scripts needs the kernel drivers, so we require
+#either the dkms module (preferred) or the source pkg (with module-assistant)
+Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}, procps, fxload, dahdi-linux, usbutils, dahdi-dkms | dahdi-source, gawk
 Conflicts: zaptel
 Replaces: zaptel
 Description: utilities for using the DAHDI kernel modules
@@ -27,6 +31,7 @@
 Package: libtonezone2.0
 Section: libs
 Architecture: linux-any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: tonezone library (runtime)
  A library for generating tones to be sent through the DAHDI telephony
@@ -37,6 +42,7 @@
 Package: libtonezone-dev
 Section: libdevel
 Architecture: linux-any
+Multi-Arch: same
 Depends: libtonezone2.0 (= ${binary:Version}), ${misc:Depends}
 Description: tonezone library (development)
  A library for generating tones to be sent through the DAHDI telephony

## dahdi-tools 2.10.2

=== Makefile ===
--- 
+++ 
@@ -60,6 +60,8 @@
 GENCONF_FILE	= /etc/dahdi/genconf_parameters
 MODPROBE_FILE	= /etc/modprobe.d/dahdi.conf
 BLACKLIST_FILE	= /etc/modprobe.d/dahdi.blacklist.conf
+BASH_COMP_DIR	= /etc/bash_completion.d
+BASH_COMP_FILE	= $(BASH_COMP_DIR)/dahdi
 
 NETSCR_DIR	:= $(firstword $(wildcard $(DESTDIR)/etc/sysconfig/network-scripts ))
 ifneq (,$(NETSCR_DIR))
@@ -67,13 +69,7 @@
   COPY_NETSCR	:= install -D ifup-hdlc $(NETSCR_TARGET)
 endif
 
-ifneq ($(wildcard .version),)
-  TOOLSVERSION:=$(shell cat .version)
-else
-ifneq ($(wildcard .svn),)
-  TOOLSVERSION=$(shell build_tools/make_version . dahdi/tools)
-endif
-endif
+TOOLSVERSION=$(shell build_tools/make_version . dahdi/tools)
 
 LTZ_A:=libtonezone.a
 LTZ_A_OBJS:=zonedata.o tonezone.o version.o
@@ -91,6 +87,7 @@
 DATA_DIR:=${datadir}/dahdi
 CONFIG_DIR:=$(sysconfdir)/dahdi
 CONFIG_FILE:=$(CONFIG_DIR)/system.conf
+UDEVRULES_DIR:=$(sysconfdir)/udev/rules.d
 
 # Utilities we build with a standard build procedure:
 UTILS		= dahdi_tool dahdi_test dahdi_monitor dahdi_speed sethdlc dahdi_cfg \
@@ -108,12 +105,23 @@
 ifeq	(1,$(PBX_HDLC))
 	BINS	+= sethdlc
 endif
-MAN_PAGES:=$(wildcard $(BINS:%=doc/%.8))
-
-PINNED_DATA_SCRIPTS:=dahdi_cfg_device_args handle_device \
-	span_assignments span_types
-PINNED_UTILS:=dahdi_map
-PINNED_CONF:=pinned-spans.conf spantype.conf
+ASSIGNED_DATA_SCRIPTS:=\
+	dahdi_handle_device	\
+	dahdi_span_config	\
+	dahdi_auto_assign_compat	\
+	span_config.d/10-dahdi-cfg	\
+	span_config.d/20-fxotune	\
+	span_config.d/50-asterisk	\
+	handle_device.d/10-span-types	\
+	handle_device.d/20-span-assignments
+
+ASSIGNED_UTILS:=dahdi_span_assignments dahdi_span_types \
+	dahdi_waitfor_span_assignments
+ASSIGNED_CONF:=assigned-spans.conf.sample span-types.conf.sample
+
+MAN_PAGES:= \
+	$(wildcard $(BINS:%=doc/%.8)) \
+	$(wildcard $(ASSIGNED_UTILS:%=doc/%.8))
 
 TEST_BINS:=patgen pattest patlooptest hdlcstress hdlctest hdlcgen hdlcverify timertest dahdi_maint
 # All the man pages. Not just installed ones:
@@ -172,7 +180,7 @@
 	$(CC) $(CFLAGS) -shared -Wl,-soname,$(LTZ_SO).$(LTZ_SO_MAJOR_VER).$(LTZ_SO_MINOR_VER) -o $@ $^ -lm
 
 dahdi_cfg: $(LTZ_A)
-dahdi_cfg: LIBS+=-lm
+dahdi_cfg: LIBS+=-lm -lpthread
 dahdi_pcap:
 	$(CC) $(CFLAGS) dahdi_pcap.c -lpcap -o $@ $<
 	
@@ -198,13 +206,14 @@
 	cp $< $@
 
 README.html: README system.conf.asciidoc init.conf.asciidoc tonezones.txt \
-  UPGRADE.txt genconf_parameters.asciidoc
-	$(ASCIIDOC) -n -a toc -a toclevels=3 $<
+  UPGRADE.txt genconf_parameters.asciidoc assigned-spans.conf.asciidoc \
+  span-types.conf.asciidoc
+	$(ASCIIDOC) -n -a toc -a toclevels=4 $<
 
 README.Astribank.html: xpp/README.Astribank
 	$(ASCIIDOC) -o $@ -n -a toc -a toclevels=4 $<
 
-# on Debian: this requires the full groof, not just groff-base.
+# on Debian: this requires the full groff, not just groff-base.
 %.8.html: %.8
 	man -Thtml $^ >$@
 
@@ -233,12 +242,12 @@
 	$(INSTALL) -d $(DESTDIR)$(CONFIG_DIR)
 	$(INSTALL) -m 644 system.conf.sample $(DESTDIR)$(CONFIG_FILE)
 endif
-ifeq ($(DAHDI_PINNED),yes)
 	install -d $(DESTDIR)$(DATA_DIR)
-	install $(PINNED_DATA_SCRIPTS) $(DESTDIR)$(DATA_DIR)/
-	install $(PINNED_UTILS) $(DESTDIR)/$(BIN_DIR)/
-	install -m 644 $(PINNED_CONF) $(DESTDIR)/$(CONFIG_DIR)/
-endif
+	tar cf - -C hotplug $(ASSIGNED_DATA_SCRIPTS) | tar xf - -C $(DESTDIR)$(DATA_DIR)/
+	install $(ASSIGNED_UTILS) $(DESTDIR)/$(BIN_DIR)/
+	install -m 644 $(ASSIGNED_CONF) $(DESTDIR)/$(CONFIG_DIR)/
+	install -d $(DESTDIR)$(BASH_COMP_DIR)
+	install -m 644 dahdi-bash-completion $(DESTDIR)$(BASH_COMP_FILE)
 
 install-libs: libs
 	$(INSTALL) -d -m 755 $(DESTDIR)/$(LIB_DIR)
@@ -301,6 +310,8 @@
 ifeq (,$(wildcard $(DESTDIR)$(BLACKLIST_FILE)))
 	$(INSTALL) -D -m 644 blacklist.sample $(DESTDIR)$(BLACKLIST_FILE)
 endif
+	$(INSTALL) -d $(DESTDIR)$(UDEVRULES_DIR)
+	$(INSTALL) -D -m 644 dahdi.rules $(DESTDIR)$(UDEVRULES_DIR)/
 ifneq (,$(COPY_NETSCR))
 	$(COPY_NETSCR)
 endif
@@ -334,6 +345,9 @@
 	else \
 		echo "Not under version control";  \
 	fi
+
+dist:
+	@./build_tools/make_dist "dahdi-tools" "$(TOOLSVERSION)"
 
 clean:
 	rm -f $(BINS) $(TEST_BINS)
@@ -367,7 +381,7 @@
 	@echo "****"
 	@exit 1
 
-.PHONY: distclean dist-clean clean all install programs tests devel data config update install-programs install-libs install-utils-subdirs utils-subdirs prereq
+.PHONY: distclean dist-clean clean all install programs tests devel data config update install-programs install-libs install-utils-subdirs utils-subdirs prereq dist
 
 FORCE:

=== xpp/Makefile ===
--- 
+++ 
@@ -20,6 +20,8 @@
 prefix		?= /usr
 datadir		?= $(prefix)/share
 mandir		?= $(datadir)/man
+sysconfdir	?= $(prefix)/etc
+udevrulesdir	?= $(sysconfdir)/udev/rules.d
 INSTALL		?= install
 
 INSTALL_DATA	= $(INSTALL) -m 644
@@ -52,7 +54,8 @@
 	-DcOCT6100_MAX_ECHO_CHANNELS=672		\
 	-DcOCT6100_MAX_MIXER_EVENTS=1344
 
-ECHO_LOADER	= echo_loader.o
+ECHO_LOADER_SRC	= echo_loader.c parse_span_specs.c
+ECHO_LOADER	= $(ECHO_LOADER_SRC:.c=.o)
 endif
 
 %.8: %
@@ -69,12 +72,33 @@
 
 PERL_MANS	= $(PERL_SCRIPTS:%=%.8)
 
-XTALK_OBJS		= xtalk/xtalk.o xtalk/xusb.o xtalk/xlist.o xtalk/debug.o
-ASTRIBANK_OBJS		= astribank_usb.o mpptalk.o $(XTALK_OBJS)
-
-ABHEXLOAD_OBJS		= astribank_hexload.o hexfile.o pic_loader.o $(ECHO_LOADER) $(ASTRIBANK_OBJS) $(OCT_HERE_OBJS)
-ABTOOL_OBJS		= astribank_tool.o $(ASTRIBANK_OBJS)
-ABALLOW_OBJS		= astribank_allow.o astribank_license.o $(ASTRIBANK_OBJS)
+# List all our sources
+XUSB_SRCS		= xtalk/xusb.c xtalk/xlist.c xtalk/debug.c
+XTALK_SRCS		= xtalk/xtalk.c
+MPPTALK_SRCS		= mpptalk.c
+ASTRIBANK_SRCS		= astribank_usb.c
+ABHEXLOAD_SRCS		= astribank_hexload.c hexfile.c pic_loader.c
+ABTOOL_SRCS		= astribank_tool.c
+ABALLOW_SRCS		= astribank_allow.c astribank_license.c
+
+SRCS	= \
+	$(XUSB_SRCS)	\
+	$(XTALK_SRCS)	\
+	$(MPPTALK_SRCS)	\
+	$(ASTRIBANK_SRCS)	\
+	$(ABHEXLOAD_SRCS)	\
+	$(ABTOOL_SRCS)	\
+	$(ABALLOW_SRCS)	\
+	$(ECHO_LOADER_SRC)
+
+# Derive object files from source list
+XUSB_OBJS		= $(XUSB_SRCS:.c=.o)
+XTALK_OBJS		= $(XTALK_SRCS:.c=.o) $(XUSB_OBJS)
+MPPTALK_OBJS		= $(MPPTALK_SRCS:.c=.o) $(XTALK_OBJS)
+ASTRIBANK_OBJS		= $(ASTRIBANK_SRCS:.c=.o) $(MPPTALK_OBJS)
+ABHEXLOAD_OBJS		= $(ABHEXLOAD_SRCS:.c=.o) $(ASTRIBANK_OBJS) $(ECHO_LOADER) $(OCT_HERE_OBJS)
+ABTOOL_OBJS		= $(ABTOOL_SRCS:.c=.o) $(ASTRIBANK_OBJS)
+ABALLOW_OBJS		= $(ABALLOW_SRCS:.c=.o) $(ASTRIBANK_OBJS)
 
 TARGETS	= .perlcheck astribank_is_starting
 PROG_INSTALL	= astribank_is_starting
@@ -102,6 +126,8 @@
 	$(INSTALL) -d $(DESTDIR)$(DATADIR)
 	$(INSTALL) xpp_fxloader astribank_hook $(DESTDIR)$(DATADIR)/
 	$(INSTALL) waitfor_xpds $(DESTDIR)$(DATADIR)/
+	$(INSTALL) -d $(DESTDIR)$(udevrulesdir)
+	$(INSTALL_DATA) xpp.rules $(DESTDIR)$(udevrulesdir)/
 	$(INSTALL) -d $(DESTDIR)$(MANDIR)
 	$(INSTALL_DATA) $(MAN_INSTALL) $(DESTDIR)$(MANDIR)/
 	$(INSTALL) -d $(DESTDIR)$(HOTPLUG_USB_DIR)
@@ -120,7 +146,7 @@
 	done
 endif
 
-CFLAGS		+= -I. -Ixtalk
+CFLAGS		+= -I. -Ixtalk -Wall -Werror
 
 astribank_hexload: $(ABHEXLOAD_OBJS)
 astribank_hexload: LIBS+=$(EXTRA_LIBS) $(USB_LIB)
@@ -166,8 +192,11 @@
 	$(RM) .depend .octasic.depend *.o xtalk/*.o $(OCT_HERE_OBJS) $(TARGETS)
 
 .PHONY: depend
+ifeq	(1,$(PBX_USB))
 depend: .depend
-.depend: *.c *.h xtalk/*.c xtalk/*.h
-	@$(CC) $(CFLAGS) -MM *.c xtalk/*.c > $@ || rm -f $@
+.depend: *.c *.h xtalk/*.c
+	@echo "Calculating dependencies"
+	@if ! $(CC) $(CFLAGS) $(OCT_CFLAGS) -MM $(SRCS) > $@; then $(RM) $@; exit 1; fi
 
 include .depend
+endif

=== debian/changelog ===
dahdi-tools (1:2.10.2-2ubuntu1) xenial; urgency=low

  * Merge from Debian testing. Remaining changes:
    - debian/control: Depend on (dahdi-dkms | dahdi-source) and gawk

 -- Stefan Bader <stefan.bader@canonical.com>  Thu, 17 Dec 2015 15:30:11 +0100

dahdi-tools (1:2.10.2-2) unstable; urgency=medium

  * gcc5.patch (Closes: #777829).

 -- Tzafrir Cohen <tzafrir@debian.org>  Sun, 28 Jun 2015 23:08:21 +0300

dahdi-tools (1:2.10.2-1) unstable; urgency=medium

  * New upstream release:
    - Removed bashism from udev hook script (Closes: #772229).
    - Builds fine with GCC 5 (Closes: #777829).
  * Build-depend on debhelper 9.

 -- Tzafrir Cohen <tzafrir@debian.org>  Fri, 26 Jun 2015 16:06:56 +0300

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Tzafrir Cohen <tzafrir@debian.org>, Mark Purcell <msp@debian.org>
 # groff, man-db and asciidoc are required for generating documentation
-Build-Depends: debhelper (>= 8), autotools-dev,
+Build-Depends: debhelper (>= 9), autotools-dev,
  dahdi-source (>= 1:2.7), libnewt-dev, bzip2, libusb-dev, asciidoc, groff, man-db
 Standards-Version: 3.9.4
 Homepage: http://www.asterisk.org/

=== debian/rules ===
--- 
+++ 
@@ -36,6 +36,7 @@
 override_dh_auto_install:
 	# also run the 'config' target, in addition to the 'install' target:
 	dh_auto_install -- config
+	rm $(CURDIR)/debian/tmp/usr/share/dahdi/span_config.d/50-asterisk
 
 print-version:
 	@@echo "Debian version:          $(DEBVERSION)"

## dahdi-tools 2.11.1

=== debian/changelog ===
dahdi-tools (1:2.11.1-3ubuntu1) bionic; urgency=medium

  * Merge from Debian unstable. Remaining change:
    - debian/control: Depend on (dahdi-dkms | dahdi-source) and gawk

 -- Bhavani Shankar <bhavi@ubuntu.com>  Wed, 01 Nov 2017 18:54:11 +0530

dahdi-tools (1:2.11.1-3) unstable; urgency=medium

  * Team upload.

  [ Tzafrir Cohen ]
  * Allow building with just asciidoc-base
  * add udevadm_path.patch (Closes: #852561)
  * Add dracut.patch: exclude xpp from dracut initramfs
  * Compat level 10
  * watch file: copy gpg sig check from dahdi-linux

 -- Bernhard Schmidt <berni@debian.org>  Wed, 11 Oct 2017 08:13:56 +0200

dahdi-tools (1:2.11.1-2ubuntu1) zesty; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - debian/control: Depend on (dahdi-dkms | dahdi-source) and gawk

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 08 Jan 2017 16:38:46 +0530

dahdi-tools (1:2.11.1-2) unstable; urgency=medium

  * VCS: we use git
  * include xpp in udev rules
  * Patch no_xtalk_send: don't install xtalk_send
  * Standards version 3.9.8

 -- Tzafrir Cohen <tzafrir@debian.org>  Tue, 15 Nov 2016 15:43:17 +0200

dahdi-tools (1:2.11.1-1) unstable; urgency=medium

  * New upstream release:
    - Support for libusb 1.0
    - Run asciidoc with TZ=UTC (Closes: #795977).
    - Builds with GCC-6 (Closes: #811932).
    - Drop patches: cflags, gcc5 (merged upstream).
  * Switch to libusb-1.0 (Closes: #810404).
  * Force the SONAME of libtonezone to be 2.0.
  * generate configure at build time.
  * Ignore generated git files.
  * fall back to running 'clean' from Makefile.legacy.
  * clean: some xpp/*.html files for case of no Makefile.
  * Fix cleaning of generated autotools files.

 -- Tzafrir Cohen <tzafrir@debian.org>  Tue, 05 Jul 2016 17:23:31 +0200

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,23 @@
 XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Tzafrir Cohen <tzafrir@debian.org>, Mark Purcell <msp@debian.org>
 # groff, man-db and asciidoc are required for generating documentation
-Build-Depends: debhelper (>= 9), autotools-dev,
- dahdi-source (>= 1:2.7), libnewt-dev, bzip2, libusb-dev, asciidoc, groff, man-db
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 10),
+ autoconf,
+ automake,
+ cpio,
+ dh-autoreconf,
+ pkg-config,
+ dahdi-source (>= 1:2.7),
+ libnewt-dev,
+ bzip2,
+ libusb-1.0-0-dev,
+ asciidoc-base | asciidoc,
+ groff,
+ man-db,
+Standards-Version: 3.9.8
 Homepage: http://www.asterisk.org/
-Vcs-Svn: svn://anonscm.debian.org/pkg-voip/dahdi-tools/trunk/
-Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-voip/dahdi-tools/
+Vcs-Git: https://anonscm.debian.org/git/pkg-voip/dahdi-tools.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-voip/dahdi-tools.git
 
 Package: dahdi
 Architecture: linux-any

=== debian/rules ===
--- 
+++ 
@@ -21,17 +21,44 @@
 FILENAME := $(PACKAGE_SRC)_$(DEB_BASE_VERSION).orig.tar.gz
 URL := http://downloads.asterisk.org/pub/telephony/$(PACKAGE_SRC)/releases/$(PACKAGE_SRC)-$(UPVERSION).tar.gz
 
+CHANGED_FILES_LIST = debian/savedfiles.lst
+CHANGED_FILES_ARCHIVE = debian/savedfiles.cpio
+
 %:
-	dh $@ --wth autotools_dev
+	dh $@ --with autoreconf
+
+override_dh_autoreconf:
+	if [ ! -f "$(CHANGED_FILES_ARCHIVE)" -a -f Makefile.in ]; then \
+	  cpio -o < $(CHANGED_FILES_LIST) > $(CHANGED_FILES_ARCHIVE); \
+	fi
+	dh_autoreconf
+
+override_dh_autoreconf_clean:
+	dh_autoreconf_clean
+	if [ -f "$(CHANGED_FILES_ARCHIVE)" ]; then \
+	  cpio -idu < $(CHANGED_FILES_ARCHIVE) && \
+	  rm -f $(CHANGED_FILES_ARCHIVE); \
+	fi
+
+# An ugly workaround because those files are included in the tarball
+override_dh_clean:
+	dh_clean -X autom4te.cache
+
+
+override_dh_auto_build:
+	$(MAKE) all docs
+	# FIXME: xpp/README.Astribank.html
+	cat dahdi.rules xpp/xpp.rules >debian/dahdi.udev
+
+override_dh_auto_clean:
+ifeq ($(wildcard Makefile),)
+	$(MAKE) -f Makefile.legacy clean
+else
+	$(MAKE) clean
+endif
 
 override_dh_auto_configure:
-	dh_auto_configure -- --enable-pinned
-
-override_dh_auto_build:
-	$(MAKE) programs docs
-	# FIXME: xpp/README.Astribank.html
-	cp dahdi.rules debian/dahdi.udev
-
+	dh_auto_configure
 
 override_dh_auto_install:
 	# also run the 'config' target, in addition to the 'install' target:
